package nl.amis.ajaxuix.view;
import java.util.Iterator;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import oracle.adf.controller.lifecycle.LifecycleContext;
import oracle.adf.controller.struts.actions.DataActionContext;
import oracle.adf.controller.struts.actions.StrutsPageLifecycle;
import oracle.adf.controller.struts.actions.StrutsUixLifecycle;
import oracle.adf.model.BindingContext;
import oracle.cabo.ui.data.MessageData;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.util.MessageResources;

public class MyStrutsUixLifecycle  extends StrutsUixLifecycle {

  /**
   * Convert Struts ActionErrors and ActionMessages and Model
   * Exceptions to UIX MessageData, so they will be displayed by the
   * standard ADF UIX message box.
   * <pre>
   *   &lt;messageBox model="${data}"/&gt;
   * </pre>
   * 
   * @param lcContext The lifecyclecontext holding the state of the lifecycle.
   */
  public void reportErrors(LifecycleContext lcContext)
  {
  // super.reportErrors(lcContext);
    MessageData md = new MessageData();
    HttpServletRequest request = lcContext.getHttpServletRequest();
    DataActionContext dac = (DataActionContext)lcContext;
    BindingContext bc = dac.getBindingContext();
    Locale locale = null;
    if (bc==null)
    {
      // binding context can be null when there is an error creating
      // the binding context, for example when a servlet filter executed
      // before the adf binding filter has forwarded to some URI,
      // bypassing the ADF binding filter that creates the context!
      locale = Locale.getDefault();
    }
    else
    {
      locale = dac.getBindingContext().getLocaleContext().getLocale();
    } 
    
    // Get resource bundle to translate the message
    // Struts stores default resource bundle under Globals.MESSAGES_KEY
    MessageResources resources = (MessageResources)request.getSession().getServletContext().getAttribute(Globals.MESSAGES_KEY);

    // We have this stacks of messages to convert:
    // - Standard Struts ActionMessages, stored on request with key Globals.MESSAGE_KEY

    ActionMessages messages = (ActionMessages)request.getAttribute(Globals.MESSAGE_KEY);
    if (messages!=null)
    {
      Iterator msgit = messages.get();
      while (msgit.hasNext())
      {
        // translate message and add to UIX MessageData
        ActionMessage message = (ActionMessage)msgit.next();        
        String text = resources.getMessage(locale,message.getKey(),message.getValues());
        md.addInfo(null,text,null);
      }      
    }
  
    lcContext.getHttpServletRequest().setAttribute("_uix.messages", md);    
  } // end reportErrors



}