package nl.amis.ajaxuix.view;
import java.util.*;

import javax.servlet.http.HttpServletRequest;

import oracle.cabo.adf.rt.InitModelListener;
import oracle.cabo.servlet.event.*;
import oracle.cabo.ui.data.MessageData;

public class UIXInitModelListener
extends InitModelListener
    implements UIXRequestListener
{



  /**
   * Don't clear _uix.messages if it already has a value. Or rather: save it before
   * calling the super.renderStarted and reinstate afterwards if it was not null
   * before calling super.
   */
    public void renderStarted(UIXRequestEvent uixrequestevent)
    {
        HttpServletRequest httpservletrequest = _getRequest(uixrequestevent);
        Object messageObject = httpservletrequest.getAttribute("_uix.messages");
        super.renderStarted(uixrequestevent);
        if (messageObject!=null)
        {
           httpservletrequest.setAttribute("_uix.messages", messageObject);
       }
    }

    private HttpServletRequest _getRequest(UIXRequestEvent uixrequestevent)
    {
        HttpServletRequest httpservletrequest = uixrequestevent.getContext().getServletRequest();
        return httpservletrequest;
    }

}